<script>
import config from '../../config';
import { required, decimal, minValue,numeric } from 'vuelidate/lib/validators';
import { outletService } from '../../services';
import { error_message, success_message } from '../../Helper/helper';
export default {
    data(){
        return {
            config:config,
            FormData:{
                minimum_order_value:'',
                cost_for_two_person:'',
                restaurant_on_off:'0',
                packaging_charge:{
                    type:'',
                    value:''
                },
                convince_charge:{
                    type:'',
                    value:''
                }
            },
            packageTypeOption:[
                { value: '', text: this.trans.get('__JSON__.Please select an option') },
                { value: 'fixed', text: this.trans.get('__JSON__.Fixed') },
                { value: 'percentage', text: this.trans.get('__JSON__.Percentage')},
            ]
            
        }
    },
    mounted(){
        this.getOtheSetting()
    },
    validations:{
        FormData:{
            minimum_order_value:{
                required,
                minValue:minValue(0)
            },
            cost_for_two_person:{
                required,
                minValue:minValue(0)
            },
            packaging_charge:{
                type:{
                    required,
                },
                value:{
                    required,                    
                }
            },
            convince_charge:{
                type:{
                    required
                },
                value:{
                    required,                    
                }
            }
        }
    },

    methods: {
        getOtheSetting(){
            outletService.getOtherSetting().then((response) => {
                if(response.data.code == 200){
                    if(Object.keys(response.data.result).length > 0){
                        this.FormData.minimum_order_value = response.data.result.minimum_order_value
                        this.FormData.cost_for_two_person = response.data.result.cost_for_two_person
                        this.FormData.restaurant_on_off = response.data.result.restaurant_on_off
                        if(Object.keys(response.data.result.packaging_charge).length > 0){
                            this.FormData.packaging_charge = response.data.result.packaging_charge
                        }
                        if(Object.keys(response.data.result.convince_charge).length > 0){
                            this.FormData.convince_charge = response.data.result.convince_charge
                        }
                    }
                }
            })

        },
        otherSettingFrom(){
            this.$v.FormData.$touch()
            if(this.$v.FormData.$invalid){
                return false;
            }else{
                outletService.otherSettingStoreUpdate(this.FormData).then((response) => {
                    if(response.data.code == 200){
                        success_message(response.data.message)
                    }else{
                        error_message(response.data.message)
                    }
                })
            }
        }
    }
}
</script>

<template>
    <div>
        <div class="row">
            <div class="col-12">
                <div class="card">
                    <div class="card-body">
                        <form @submit.prevent="otherSettingFrom" v-on:keydown.enter.prevent>
                            <div class="row">
                                <div class="col-md-2">
                                    <h5>{{ trans.get('__JSON__.Restaurant On Off') }}</h5>
                                </div>
                                <div class="col-md-6">
                                    <div class="swtich-data ml-4">
                                        <label class="switch">
                                            <input type="checkbox" id="togBtn" class="switch-on" true-value="1"
                                                false-value="0" v-model="FormData.restaurant_on_off" />
                                            <div class="slider round">
                                                <span class="on">{{ trans.get('__JSON__.ON') }}</span>
                                                <span class="off">{{ trans.get('__JSON__.OFF') }}</span>
                                            </div>
                                        </label>
                                    </div>
                                </div>
                            </div>
                            <div class="row mt-4">
                                <div class="col-md-2">
                                    <h5>{{ trans.get('__JSON__.Minimum Order Values') }}</h5>
                                </div>
                                <div class="col-md-6">
                                    <input 
                                    v-model="$v.FormData.minimum_order_value.$model" 
                                    type="number" 
                                    class="form-control"
                                    :placeholder="trans.get('__JSON__.Minimum Order Values')"
                                    :class="{'is-invalid' : $v.FormData.minimum_order_value.$error}"
                                    />
                                    <div v-if="$v.FormData.minimum_order_value.$error" class="invalid-feedback">
                                        <span v-if="!$v.FormData.minimum_order_value.required">
                                            {{ trans.get('__JSON__.Please Enter A Minimum Order Values') }}
                                        </span>
                                        <span v-if="!$v.FormData.minimum_order_value.minValue">
                                            {{ trans.get('__JSON__.Please Enter A Minimum 0 Order Values') }}
                                        </span>
                                    </div>
                                </div>
                            </div>

                            <div class="row mt-4">
                                <div class="col-md-2">
                                    <h5>{{ trans.get('__JSON__.Cost for Two Person') }}</h5>
                                </div>
                                <div class="col-md-6">
                                    <input 
                                    v-model="$v.FormData.cost_for_two_person.$model" 
                                    type="number" 
                                    class="form-control"
                                    :placeholder="trans.get('__JSON__.Cost for Two Person')"
                                    :class="{'is-invalid' : $v.FormData.cost_for_two_person.$error}"
                                    />
                                    <div v-if="$v.FormData.cost_for_two_person.$error" class="invalid-feedback">
                                        <span v-if="!$v.FormData.cost_for_two_person.required">
                                            {{ trans.get('__JSON__.Please Enter A Cost for Two Person') }}
                                        </span>
                                        <span v-if="!$v.FormData.cost_for_two_person.minValue">
                                            {{ trans.get('__JSON__.Please Enter A Minimum 0 Values') }}
                                        </span>
                                    </div>
                                </div>
                            </div>

                            <div class="row mt-4">
                                <div class="col-md-2">
                                    <h5>{{ trans.get('__JSON__.Packaging Charge') }}</h5>
                                </div>
                                <div class="col-md-4">
                                    <b-form-select 
                                    v-model="$v.FormData.packaging_charge.type.$model" 
                                    :options="packageTypeOption"
                                    :class="{'is-invalid' : $v.FormData.packaging_charge.type.$error}"
                                    ></b-form-select>
                                    <div v-if="$v.FormData.packaging_charge.type.$error" class="invalid-feedback">
                                        <span v-if="!$v.FormData.packaging_charge.type.required">
                                            {{ trans.get('__JSON__.Please select an option') }}
                                        </span>
                                    </div>
                                </div>
                                <div class="col-md-4">
                                    <input
                                    v-model="$v.FormData.packaging_charge.value.$model"
                                    type="number" 
                                    class="form-control"
                                    :placeholder="trans.get('__JSON__.Enter Packaging Charge')"
                                    :class="{'is-invalid' : $v.FormData.packaging_charge.value.$error}"
                                    min="0.0"
                                    step="0.01"
                                    />
                                    <div v-if="$v.FormData.packaging_charge.value.$error" class="invalid-feedback">
                                        <span v-if="!$v.FormData.packaging_charge.value.required">
                                            {{ trans.get('__JSON__.Please Enter Packaging Charge') }}
                                        </span>
                                    </div>
                                    <div v-if="$v.FormData.packaging_charge.value.$error" class="invalid-feedback">
                                        <span v-if="!$v.FormData.packaging_charge.value.numeric">
                                            {{ trans.get('__JSON__.Please Enter numeric value') }}
                                        </span>
                                    </div>
                                </div>
                            </div>
                            
                            <div class="row mt-4">
                                <div class="col-md-2">
                                    <h5>{{ trans.get('__JSON__.Convince Charge') }}</h5>
                                </div>
                                <div class="col-md-4">
                                    <b-form-select 
                                    v-model="$v.FormData.convince_charge.type.$model" 
                                    :options="packageTypeOption"
                                    :class="{'is-invalid' : $v.FormData.convince_charge.type.$error}"
                                    ></b-form-select>
                                    <div v-if="$v.FormData.convince_charge.type.$error" class="invalid-feedback">
                                        <span v-if="!$v.FormData.convince_charge.type.required">
                                            {{ trans.get('__JSON__.Please select an option') }}
                                        </span>
                                    </div>
                                </div>
                                <div class="col-md-4">
                                    <input 
                                    v-model="$v.FormData.convince_charge.value.$model" 
                                    type="number" 
                                    class="form-control"
                                    :placeholder="trans.get('__JSON__.Enter Convince Charge')"
                                    :class="{'is-invalid' : $v.FormData.convince_charge.value.$error}"
                                    min="0.0"
                                    step="0.01"
                                    />
                                    <div v-if="$v.FormData.convince_charge.value.$error" class="invalid-feedback">
                                        <span v-if="!$v.FormData.convince_charge.value.required">
                                            {{ trans.get('__JSON__.Please Enter Convince Charge') }}
                                        </span>
                                    </div>
                                </div>
    
                                <div class="col-md-12 text-center mt-4">
                                        <button
                                            class="btn btn-primary"
                                            @click="$emit('actionChanged',3)"
                                            >{{ trans.get('__JSON__.Previous') }}
                                        </button>
                                        <button
                                            v-if="$auth.hasPermission(config.permissions.outlet_write)"
                                            class="btn btn-primary"
                                            type="submit"
                                            >{{ trans.get('__JSON__.Save') }}
                                        </button>
                                    </div>
                            </div>
                        </form>
                    </div>
                </div>
            </div>
        </div>
    </div>
</template>

<style scoped>
.custom-select{
    width: 60% !important;
}
</style>